(function() {
  var ENTER, MultiSelectOptionItem, PropTypes, React, createClass, li;

  React = require('react');

  createClass = require('create-react-class');

  PropTypes = require('prop-types');

  li = require('react-dom-factories').li;

  ENTER = require('../constants/keyboard').ENTER;

  MultiSelectOptionItem = createClass({
    displayName: 'MultiSelectOptionItem',
    propTypes: {
      option: PropTypes.object.isRequired,
      isSelected: PropTypes.bool.isRequired,
      isFocused: PropTypes.bool.isRequired,
      labelField: PropTypes.string,
      onRemove: PropTypes.func.isRequired,
      onAdd: PropTypes.func.isRequired
    },
    render: function() {
      var className, isFocused, isSelected, label, labelField, option, ref;
      ref = this.props, option = ref.option, isSelected = ref.isSelected, labelField = ref.labelField, isFocused = ref.isFocused;
      label = option[labelField] || option;
      className = 'multi-opt';
      if (isSelected) {
        className += ' selected';
      }
      if (isFocused) {
        className += ' focused';
      }
      return li({
        className: className,
        onClick: this.handleClick,
        onMouseOver: this.handleMouseOver,
        title: label
      }, label);
    },
    handleClick: function() {
      var isSelected, onAdd, onRemove, option, ref;
      ref = this.props, option = ref.option, isSelected = ref.isSelected, onAdd = ref.onAdd, onRemove = ref.onRemove;
      if (isSelected) {
        return onRemove(option);
      } else {
        return onAdd(option);
      }
    },
    handleMouseOver: function() {
      var focusOption, index, ref;
      ref = this.props, index = ref.index, focusOption = ref.focusOption;
      return focusOption(index);
    }
  });

  module.exports = React.createFactory(MultiSelectOptionItem);

}).call(this);
