(function() {
  var DOWN_ARROW, ENTER, ESCAPE, MultiSelectOptionItem, MultiSelectOptionList, PropTypes, Pvr, React, SPACE, TAB, UP_ARROW, createClass, map, ref, ul;

  React = require('react');

  createClass = require('create-react-class');

  PropTypes = require('prop-types');

  Pvr = React.createFactory(require('./pvr'));

  map = require('lodash/map');

  MultiSelectOptionItem = require('./multi_select_option_item');

  ul = require('react-dom-factories').ul;

  ref = require('../constants/keyboard'), ESCAPE = ref.ESCAPE, DOWN_ARROW = ref.DOWN_ARROW, UP_ARROW = ref.UP_ARROW, SPACE = ref.SPACE, TAB = ref.TAB, ENTER = ref.ENTER;

  MultiSelectOptionList = createClass({
    displayName: 'MultiSelectOptionList',
    propTypes: {
      options: PropTypes.array.isRequired,
      values: PropTypes.array.isRequired,
      onRemove: PropTypes.func.isRequired,
      onAdd: PropTypes.func.isRequired,
      anchor: PropTypes.any,
      close: PropTypes.func.isRequired,
      onClose: PropTypes.func.isRequired,
      valueField: PropTypes.string,
      labelField: PropTypes.string,
      returnFullObjects: PropTypes.bool
    },
    getInitialState: function() {
      return {
        focused: 0
      };
    },
    componentDidMount: function() {
      this.keyNav = false;
      return document.addEventListener('keydown', this.handleKeydown);
    },
    componentWillUnmount: function() {
      var onClose;
      onClose = this.props.onClose;
      document.removeEventListener('keydown', this.handleKeydown);
      return onClose();
    },
    render: function() {
      var anchor, clientWidth, close, focused, i, labelField, onAdd, onRemove, optionItem, optionList, options, ref1, valueField, width;
      focused = this.state.focused;
      ref1 = this.props, anchor = ref1.anchor, options = ref1.options, close = ref1.close, valueField = ref1.valueField, labelField = ref1.labelField, onAdd = ref1.onAdd, onRemove = ref1.onRemove;
      clientWidth = anchor.clientWidth;
      optionList = (function() {
        var j, len, results;
        results = [];
        for (i = j = 0, len = options.length; j < len; i = ++j) {
          optionItem = options[i];
          results.push(MultiSelectOptionItem({
            key: optionItem[valueField] || optionItem,
            option: optionItem,
            isSelected: this.optionIsSelected(optionItem),
            isFocused: i === focused,
            onAdd: onAdd,
            onRemove: onRemove,
            labelField: labelField,
            focusOption: this.focusOption,
            index: i
          }));
        }
        return results;
      }).call(this);
      width = clientWidth - (clientWidth * .1);
      return Pvr({
        anchor: anchor,
        width: width < 470 ? width : 470,
        direction: 'below',
        animateIn: false,
        close: close,
        height: 'auto',
        autoHeightClass: 'multiselect-option-list',
        nibColor: 'white',
        styleMixin: {
          transition: 'top 300ms ease-out, left 300ms ease-out'
        }
      }, ul({
        className: 'multiselect-option-list',
        onMouseMove: this.handleMouseMove,
        onKeyDown: this.handleKeydown,
        ref: (function(_this) {
          return function(listEl) {
            _this.listEl = listEl;
          };
        })(this)
      }, optionList));
    },
    handleKeydown: function(e) {
      var close, focused, keyCode, lastIndex, options, ref1;
      ref1 = this.props, close = ref1.close, options = ref1.options;
      keyCode = e.keyCode;
      if (keyCode === TAB || keyCode === SPACE) {
        e.preventDefault();
      }
      if (keyCode === ESCAPE || keyCode === SPACE) {
        return close();
      }
      if (keyCode === UP_ARROW || keyCode === DOWN_ARROW) {
        e.preventDefault();
        focused = this.state.focused;
        if (keyCode === DOWN_ARROW) {
          focused++;
        }
        if (keyCode === UP_ARROW) {
          focused--;
        }
        lastIndex = options.length - 1;
        focused = focused < 0 ? 0 : focused;
        focused = focused > lastIndex ? lastIndex : focused;
        this.keyNav = true;
        return this.setState({
          focused: focused
        }, this.adjustScroll);
      }
      if (keyCode === ENTER) {
        return this.selectFocused();
      }
    },
    selectFocused: function() {
      var focused, onAdd, onRemove, option, options, ref1;
      focused = this.state.focused;
      ref1 = this.props, options = ref1.options, onAdd = ref1.onAdd, onRemove = ref1.onRemove;
      option = options[focused];
      if (this.optionIsSelected(option)) {
        return onRemove(option);
      } else {
        return onAdd(option);
      }
    },
    focusOption: function(focused) {
      if (this.keyNav === false) {
        return this.setState({
          focused: focused
        });
      }
    },
    optionIsSelected: function(option) {
      var entry, flatValues, j, len, ref1, returnFullObjects, value, valueField, values;
      ref1 = this.props, values = ref1.values, valueField = ref1.valueField, returnFullObjects = ref1.returnFullObjects;
      value = option[valueField];
      if (returnFullObjects) {
        flatValues = map(values, valueField);
      } else {
        flatValues = values;
      }
      for (j = 0, len = flatValues.length; j < len; j++) {
        entry = flatValues[j];
        if (value === entry) {
          return true;
        }
      }
      return false;
    },
    handleMouseMove: function() {
      return this.keyNav = false;
    },
    adjustScroll: function() {
      var children, clientHeight, focused, focusedBottom, focusedChild, focusedTop, liHeight, ref1, scrollTop;
      ref1 = this.listEl, scrollTop = ref1.scrollTop, clientHeight = ref1.clientHeight, children = ref1.children;
      focused = this.state.focused;
      focusedChild = children[focused];
      liHeight = focusedChild.clientHeight;
      focusedTop = focusedChild.offsetTop;
      focusedBottom = focusedTop + liHeight;
      if (focusedBottom > clientHeight + scrollTop) {
        return this.listEl.scrollTop = focusedBottom - clientHeight;
      } else if (focusedTop < scrollTop) {
        return this.listEl.scrollTop = focusedTop;
      }
    }
  });

  module.exports = React.createFactory(MultiSelectOptionList);

}).call(this);
