# Widgets Documentation
Component documentation blocks should look as follows:
```coffeescript
###&
  @props.myPropName - [Object|Boolean|String|Number|Array|Function] - Optional|Required
  Here is a description of myPropName. This is where you can leave
  Multi-line notes to describe the functionality of this prop.
&###
```
[Address](./components/address.coffee.md) `address.coffee`   
[AddressUK](./components/address_uk.coffee.md) `address_uk.coffee`   
[AlertModal](./components/alert_modal.coffee.md) `alert_modal.coffee`   
[CheckboxInput](./components/checkbox_input.coffee.md) `checkbox_input.coffee`   
[Chevron](./components/chevron.coffee.md) `chevron.coffee`   
[CircleX](./components/circle_x_button.coffee.md) `circle_x_button.coffee`   
[ConfirmSave](./components/confirm_save.coffee.md) `confirm_save.coffee`   
[ConfirmUserAction](./components/confirm_user_action.coffee.md) `confirm_user_action.coffee`   
[DATE_TIME](./components/date_time.coffee.md) `date_time.coffee`   
[DatePicker](./components/date_picker.coffee.md) `date_picker.coffee`   
[Dialogue](./components/dialogue.coffee.md) `dialogue.coffee`   
[DialogueBox](./components/dialogue_box.coffee.md) `dialogue_box.coffee`   
[Draggable](./components/draggable.coffee.md) `draggable.coffee`   
[FILE_TYPES](./components/file_types.coffee.md) `file_types.coffee`   
[FileDisplay](./components/file_display.coffee.md) `file_display.coffee`   
[FileInput](./components/file_input.coffee.md) `file_input.coffee`   
[Form](./components/form.coffee.md) `form.coffee`   
[FormAlertItem](./components/form_alert_item.coffee.md) `form_alert_item.coffee`   
[GridFormCheckBox](./components/grid_form_checkbox.coffee.md) `grid_form_checkbox.coffee`   
[GridFormDatePicker](./components/grid_form_date_picker.coffee.md) `grid_form_date_picker.coffee`   
[GridFormInput](./components/grid_form_input.coffee.md) `grid_form_input.coffee`   
[GridFormRichText](./components/grid_form_rich_text.coffee.md) `grid_form_rich_text.coffee`   
[IOSToggleSwitch](./components/ios_toggle_switch.coffee.md) `ios_toggle_switch.coffee`   
[IframeEmbedder](./components/iframe_embedder.coffee.md) `iframe_embedder.coffee`   
[InfoModal](./components/info_modal.coffee.md) `info_modal.coffee`   
[InfoPvr](./components/info_pvr.coffee.md) `info_pvr.coffee`   
[InputTypeAhead](./components/input_type_ahead.coffee.md) `input_type_ahead.coffee`   
[KEYBOARD](./components/keyboard.coffee.md) `keyboard.coffee`   
[Modal](./components/modal.coffee.md) `modal.coffee`   
[MultiSelect](./components/multi_select.coffee.md) `multi_select.coffee`   
[MultiSelectOptionItem](./components/multi_select_option_item.coffee.md) `multi_select_option_item.coffee`   
[MultiSelectOptionList](./components/multi_select_option_list.coffee.md) `multi_select_option_list.coffee`   
[MultiSelectValue](./components/multi_select_value.coffee.md) `multi_select_value.coffee`   
[NoAccess](./components/no_access.coffee.md) `no_access.coffee`   
[Note](./components/note.coffee.md) `note.coffee`   
[PDFViewer](./components/pdf_viewer.coffee.md) `pdf_viewer.coffee`   
[ProgressBar](./components/progress_bar.coffee.md) `progress_bar.coffee`   
[Pvr](./components/pvr.coffee.md) `pvr.coffee`   
[PvrInfoItem](./components/pvr_info_item.coffee.md) `pvr_info_item.coffee`   
[RTEButton](./components/rte_button.coffee.md) `rte_button.coffee`   
[RTEButtonRow](./components/rte_button_row.coffee.md) `rte_button_row.coffee`   
[RadioInput](./components/radio_input.coffee.md) `radio_input.coffee`   
[SearchInput](./components/search_input.coffee.md) `search_input.coffee`   
[Select](./components/select.coffee.md) `select.coffee`   
[SelectInput2](./components/select_input_2.coffee.md) `select_input_2.coffee`   
[SelectInputCustom](./components/select_input_custom.coffee.md) `select_input_custom.coffee`   
[SelectInputCustomOptions](./components/select_input_custom_options.coffee.md) `select_input_custom_options.coffee`   
[SelectPvr](./components/select_pvr.coffee.md) `select_pvr.coffee`   
[SelectPvrOption](./components/select_pvr_option.coffee.md) `select_pvr_option.coffee`   
[TextInput](./components/text_input.coffee.md) `text_input.coffee`   
[TextInput2](./components/text_input_2.coffee.md) `text_input_2.coffee`   
[Textarea](./components/textarea.coffee.md) `textarea.coffee`   
[ToggleButton](./components/toggle_button.coffee.md) `toggle_button.coffee`   
[ToggleButtonArray](./components/toggle_button_array.coffee.md) `toggle_button_array.coffee`   
[animationMixin](./components/animation_mixin.coffee.md) `animation_mixin.coffee`   
[columnLayoutMixin](./components/column_layout_mixin.coffee.md) `column_layout_mixin.coffee`   
[context_wrapper](./components/context_wrapper.coffee.md) `context_wrapper.coffee`   
[delete](./components/delete.coffee.md) `delete.coffee`   
[dialogueMixin](./components/dialogue_mixin.coffee.md) `dialogue_mixin.coffee`   
[dispatcher](./components/dispatcher.coffee.md) `dispatcher.coffee`   
[filterTextMixin](./components/filter_text.coffee.md) `filter_text.coffee`   
[formValidationMixin](./components/form_validation.coffee.md) `form_validation.coffee`   
[global_store](./components/global_store.coffee.md) `global_store.coffee`   
[grid_form_add_button](./components/grid_form_add_button.coffee.md) `grid_form_add_button.coffee`   
[grid_form_section_title](./components/grid_form_section_title.coffee.md) `grid_form_section_title.coffee`   
[imagePreloaderMixin](./components/image_preloader.coffee.md) `image_preloader.coffee`   
[index](./components/index.coffee.md) `index.coffee`   
[inputMixin](./components/input_mixin.coffee.md) `input_mixin.coffee`   
[loadingMixin](./components/loading_mixin.coffee.md) `loading_mixin.coffee`   
[multiSelectorMixin](./components/multi_selector.coffee.md) `multi_selector.coffee`   
[patientBlockMenuMixin](./components/patient_block_menu.coffee.md) `patient_block_menu.coffee`   
[scrollLoaderMixin](./components/scroll_loader.coffee.md) `scroll_loader.coffee`   
[spinner](./components/spinner.coffee.md) `spinner.coffee`   
[transitionOutMixin](./components/transition_out.coffee.md) `transition_out.coffee`   
[utils](./components/utils.coffee.md) `utils.coffee`   
[validation](./components/validation.coffee.md) `validation.coffee`   
[validation_actions](./components/validation_actions.coffee.md) `validation_actions.coffee`   
[validation_store](./components/validation_store.coffee.md) `validation_store.coffee`   
[warning](./components/warning.coffee.md) `warning.coffee`   