var React = require('react');

exports = {
  // Components
  Address: require('./dist/components/address'),
  AddressUK: require('./dist/components/address_uk'),
  AlertModal: require('./dist/components/alert_modal'),
  CheckboxInput: require('./dist/components/checkbox_input'),
  Chevron: require('./dist/components/chevron'),
  CircleXButton: require('./dist/components/circle_x_button'),
  ConfirmSave: require('./dist/components/confirm_save'),
  ConfirmUserAction: require('./dist/components/confirm_user_action'),
  DatePicker: require('./dist/components/date_picker'),
  Draggable: require('./dist/components/draggable'),
  FileDisplay: require('./dist/components/file_display'),
  FileInput: require('./dist/components/file_input'),
  Form: require('./dist/components/form'),
  FormAlertItem: require('./dist/components/form_alert_item'),
  GridFormCheckbox: require('./dist/components/grid_form/grid_form_checkbox'),
  GridFormInput: require('./dist/components/grid_form/grid_form_input'),
  GridFormRichText: require('./dist/components/grid_form/grid_form_rich_text'),
  GridFormSectionTitle: require('./dist/components/grid_form/grid_form_section_title'),
  GridFormAddButton: require('./dist/components/grid_form/grid_form_add_button'),
  GridFormDatePicker: require('./dist/components/grid_form/grid_form_date_picker'),
  IframeEmbedder: require('./dist/components/iframe_embedder'),
  InfoModal: require('./dist/components/info_modal'),
  InfoPvr: require('./dist/components/info_pvr'),
  InputTypeAhead: require('./dist/components/input_type_ahead'),
  IosToggleSwitch: require('./dist/components/ios_toggle_switch'),
  Modal: require('./dist/components/modal'),
  MultiSelect: require('./dist/components/multi_select'),
  NoAccess: require('./dist/components/no_access'),
  Note: require('./dist/components/note'),
  PdfViewer: require('./dist/components/pdf_viewer'),
  ProgressBar: require('./dist/components/progress_bar'),
  Pvr: require('./dist/components/pvr'),
  PvrInfoItem: require('./dist/components/pvr_info_item'),
  RadioInput: require('./dist/components/radio_input'),
  SearchInput: require('./dist/components/search_input'),
  Select: require('./dist/components/select'),
  SelectInput2: require('./dist/components/select_input_2'),
  SelectInputCustomOptions: require('./dist/components/select_input_custom_options'),
  SelectPvr: require('./dist/components/select_pvr'),
  Spinner: require('./dist/components/spinner'),  
  Textarea: require('./dist/components/textarea'),
  TextInput: require('./dist/components/text_input'),
  TextInput2: require('./dist/components/text_input_2'),
  ToggleButtonArray: require('./dist/components/toggle_button_array'),

  // Constants
  KEYBOARD: require('./dist/constants/keyboard'),
  DATE_TIME: require('./dist/constants/date_time'),

  // Mixins
  animationMixin: require('./dist/mixins/animation_mixin'),
  dialogueMixin: require('./dist/mixins/dialogue_mixin'),
  filterTextMixin: require('./dist/mixins/filter_text'),
  formValidationMixin: require('./dist/mixins/form_validation'),
  imagePreloaderMixin: require('./dist/mixins/image_preloader'),
  inputMixin: require('./dist/mixins/input_mixin'),
  loadingMixin: require('./dist/mixins/loading_mixin'),
  multiSelectorMixin: require('./dist/mixins/multi_selector'),
  patientBlockMenuMixin: require('./dist/mixins/patient_block_menu'),
  transitionOutMixin: require('./dist/mixins/transition_out'),
  columnLayoutMixin: require('./dist/mixins/column_layout_mixin'),
  scrollLoaderMixin: require('./dist/mixins/scroll_loader'),

  // Utils
  utils: require('./dist/utils'),
  validation: require('./dist/validation'),

  // Plain JS files for JSX implementations
  jsx: {}
};

// Also attach factory versions; also include mixins and constants for destructured assignment
for(var key in exports) {
  if(key === 'jsx') {
    continue;
  }

  // Mixins, Constants, and Utils
  else if(key.toLowerCase().search('mixin') > -1 || key === key.toUpperCase() || key === 'utils' || key === 'validation') {
    exports.jsx[key] = exports[key];
  }

  // Components
  else { 
    // Add the JS file to the JSX object
    exports.jsx[key] = exports[key];

    // Add the factory version to replace the original JS
    exports[key] = React.createFactory(exports[key]);
  }
}

module.exports = exports
