React = require 'react'
createClass = require 'create-react-class'
PropTypes = require 'prop-types'

{div, span, button} = require 'react-dom-factories'

MultiSelectValue = createClass

  displayName: 'MultiSelectValue'

  propTypes:
    value: PropTypes.oneOfType([
      PropTypes.object
      PropTypes.string
      PropTypes.number
    ]).isRequired
    onRemove: PropTypes.func.isRequired
    disabled: PropTypes.bool
    labelField: PropTypes.string

  render: ->
    {labelField, value, disabled} = @props

    label = value[labelField] or value

    div {
      className: 'multiselect-value'
    }, [
      span {
        key: 'label'
      }, label
      button {
        key: 'remove'
        onClick: @handleRemove
        tabIndex: -1
        disabled: disabled
      }
    ]
  
  handleRemove: (e) ->
    e.stopPropagation()
    {onRemove, value} = @props
    onRemove value


module.exports = React.createFactory(MultiSelectValue)