React = require 'react'
PropTypes = require 'prop-types'
createClass = require 'create-react-class'
assign = require 'lodash/assign'

{div} = require 'react-dom-factories'

###&
  @general
  No Access component used where permissions aren't sufficient

  @props.styleOverrides - [Object] - Optional
  CSS styles used to override defaults

  @props.displayText - [String] - Optional
  Primary text displayed in No Access message
&###

NoAccess = createClass
  
  displayName: 'NoAccess'

  propTypes:
    displayText: PropTypes.string
    styleOverrides: PropTypes.object

  getDefaultProps: ->
    styleOverrides: {}
    displayText: ''
  
  render: ->
    {displayText, styleOverrides} = @props

    # Figure out which app we're in based on the location
    {pathname} = window.location
    appName = (->
      if pathname.search('/admin') > -1 then 'System Manager'
      else if pathname.search('/portal') > -1 then 'Engage'
      else 'Consult'
    )()

    unless displayText then displayText = t "Your user role does not contain the required permissions to use this feature of __appName__.", { appName: appName }

    styles = 
      fontSize: '16px'
      backgroundPosition: "center 150px"
      top: 0
      paddingTop: 230
    
    assign styles, styleOverrides

    div {
      className: 'no-access'
      style: styles
    }, [
      div {
        className: 'no-access-message'
        key: 'message'
      }, displayText
    ]


module.exports = NoAccess